package com.example.moscowgo;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.IntentSender;
import android.content.pm.PackageManager;
import android.location.Location;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.os.Handler;
import android.support.v4.app.ActivityCompat;
import android.util.Log;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GoogleApiAvailability;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.common.api.PendingResult;
import com.google.android.gms.common.api.ResultCallback;
import com.google.android.gms.common.api.Status;
import com.google.android.gms.location.LocationListener;
import com.google.android.gms.location.LocationRequest;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.location.LocationSettingsRequest;
import com.google.android.gms.location.LocationSettingsResult;
import com.google.android.gms.location.LocationSettingsStates;
import com.google.android.gms.location.LocationSettingsStatusCodes;

import java.text.DateFormat;
import java.util.Date;

public class Splash extends Activity implements
        LocationListener,
        GoogleApiClient.ConnectionCallbacks,
        GoogleApiClient.OnConnectionFailedListener{

    // Splash screen timer
    private static int SPLASH_TIME_OUT = 3000;
    TextView txt_des;
    static final int REQUEST_CODE_RECOVER_PLAY_SERVICES = 1001;
    static final int REQUEST_CODE_PICK_ACCOUNT = 1002;
    private static final int PLAY_SERVICES_RESOLUTION_REQUEST = 9000;
    private static final String TAG = "LocationActivity";
    private static final long INTERVAL = 500 * 2;
    private static final long FASTEST_INTERVAL = 500 * 1;
    Button btnFusedLocation,btnShowplace;
    TextView tvLocation;
    LocationRequest mLocationRequest;
    GoogleApiClient mGoogleApiClient;
    Location mCurrentLocation;
    String mLastUpdateTime;
    private String lat, lng;
    boolean flag=false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        createLocationRequest();
        mGoogleApiClient = new GoogleApiClient.Builder(this)
                .addApi(LocationServices.API)
                .addConnectionCallbacks(this)
                .addOnConnectionFailedListener(this)
                .build();

        setContentView(R.layout.splash_activity);
        initi();

        if(!InternetConnection()){

            txt_des.setText("Please check your Internet Connection.");
        }else {

            locationChecker(mGoogleApiClient, Splash.this);

            if(txt_des.length()== 0 && flag) {

                new Handler().postDelayed(new Runnable() {
                    /*
                     * Showing splash screen with a timer. This will be useful when you
                     * want to show case your app logo / company
                     */
                    @Override
                    public void run() {
                       
                        Intent i = new Intent(Splash.this, HomeScreen.class);
                        startActivity(i);
                        
                        finish();
                    }
                }, SPLASH_TIME_OUT);
            }
        }

    }

    protected void createLocationRequest() {
        mLocationRequest = new LocationRequest();
 mLocationRequest.setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);
    }

    public void initi(){
        txt_des=(TextView) findViewById(R.id.txt_des);
    }

    @Override
    public void onStart() {
        super.onStart();
        Log.d(TAG, "onStart fired ..............");
        mGoogleApiClient.connect();
    }

    @Override
    public void onStop() {
        super.onStop();
        Log.d(TAG, "onStop fired ..............");
        mGoogleApiClient.disconnect();
        Log.d(TAG, "isConnected ...............: " + mGoogleApiClient.isConnected());
    }

    private boolean checkPlayServices() {
        GoogleApiAvailability apiAvailability = GoogleApiAvailability.getInstance();
        int resultCode = apiAvailability.isGooglePlayServicesAvailable(this);
        if (resultCode != ConnectionResult.SUCCESS) {
            if (apiAvailability.isUserResolvableError(resultCode)) {
                apiAvailability.getErrorDialog(this, resultCode, PLAY_SERVICES_RESOLUTION_REQUEST).show();
            } else {
                Log.i(TAG, "This device is not supported.");
                finish();
            }
            return false;
        }
        return true;
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        switch (requestCode) {
            case REQUEST_CODE_RECOVER_PLAY_SERVICES:
                if (resultCode == RESULT_CANCELED) {
                    Toast.makeText(this, "Google Play Services must be installed.",
                            Toast.LENGTH_SHORT).show();
                    finish();
                }
                return;
        }
        super.onActivityResult(requestCode, resultCode, data);
    }

    @Override
    public void onConnected(Bundle bundle) {
        Log.d(TAG, "onConnected - isConnected ...............: " + mGoogleApiClient.isConnected());
        startLocationUpdates();
    }

    protected void startLocationUpdates() {
        if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
         
            return;
        }
        PendingResult<Status> pendingResult = LocationServices.FusedLocationApi.requestLocationUpdates(
                mGoogleApiClient, mLocationRequest, this);
        Log.d(TAG, "Location update started ..............: ");
    }

    @Override
    public void onConnectionSuspended(int i) {
        Log.d(TAG, "Location Cancel: ");
    }

    @Override
    public void onConnectionFailed(ConnectionResult connectionResult) {
        Log.d(TAG, "Connection failed: " + connectionResult.toString());
    }

    @Override
    public void onLocationChanged(Location location) {
        Log.d(TAG, "Firing onLocationChanged..............................................");
        mCurrentLocation = location;
        mLastUpdateTime = DateFormat.getTimeInstance().format(new Date());

        updateUI();
    }

    private void updateUI() {
        Log.d(TAG, "UI update initiated .............");

        if (null != mCurrentLocation) {
            lat = String.valueOf(mCurrentLocation.getLatitude());
            lng = String.valueOf(mCurrentLocation.getLongitude());


            new Handler().postDelayed(new Runnable() {
                
                @Override
                public void run() {
                    Intent i = new Intent(Splash.this, HomeScreen.class);
                    i.putExtra("lat",lat);
                    i.putExtra("lng",lng);
                    startActivity(i);
             
                    finish();
                }
            }, SPLASH_TIME_OUT);
        }

    }

    @Override
    protected void onPause() {
        super.onPause();
        stopLocationUpdates();
    }

    protected void stopLocationUpdates() {
        LocationServices.FusedLocationApi.removeLocationUpdates(
                mGoogleApiClient, this);
        Log.d(TAG, "Location update stopped .......................");
    }

    @Override
    public void onResume() {
        super.onResume();

        if (!checkPlayServices()) {
            finish();
        }

        if (mGoogleApiClient.isConnected()) {
            Log.d(TAG, "Location update resumed .....................");
            startLocationUpdates();
        }
    }


    public void locationChecker(GoogleApiClient mGoogleApiClient, final Activity activity) {
        LocationRequest locationRequest = LocationRequest.create();
        locationRequest.setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);
        locationRequest.setInterval(30 * 1000);
        locationRequest.setFastestInterval(5 * 1000);
        LocationSettingsRequest.Builder builder = new LocationSettingsRequest.Builder().addLocationRequest(locationRequest);
        builder.setAlwaysShow(true);
        PendingResult<LocationSettingsResult> result = LocationServices.SettingsApi.checkLocationSettings(mGoogleApiClient, builder.build());
        result.setResultCallback(new ResultCallback<LocationSettingsResult>() {
            @Override
            public void onResult(LocationSettingsResult result) {
                final Status status = result.getStatus();
                final LocationSettingsStates state = result.getLocationSettingsStates();
                switch (status.getStatusCode()) {
                    case LocationSettingsStatusCodes.SUCCESS:
                        flag=true;
                        break;
                    case LocationSettingsStatusCodes.RESOLUTION_REQUIRED:
                        
                        try {
                            startResolutionForResult(),
                            onActivityResult().
                            status.startResolutionForResult(Splash.this, 1000);

                        } catch (IntentSender.SendIntentException e) {
                            
                            Log.d("I am in ", "catch");
                        }
                        break;
                    case LocationSettingsStatusCodes.SETTINGS_CHANGE_UNAVAILABLE:
                        Log.d("I am in ", "SETTINGS_CHANGE_UNAVAILABLE");
                        break;
                }
            }
        });

    }

    public boolean InternetConnection(){

        Context context=getApplication();
        ConnectivityManager cm =
                (ConnectivityManager)context.getSystemService(Context.CONNECTIVITY_SERVICE);

        NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
        boolean isConnected = activeNetwork != null &&
                activeNetwork.isConnectedOrConnecting();
        return isConnected;
    }
}

//Home Activity
package com.example.moscowgo;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.LinearLayout;

public class HomeScreen extends Activity {

    LinearLayout linearLayout;
    Intent intent;
    double latitude,longitude;
    private int PROXIMITY_RADIUS = 1000;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.home_screen_activity);

        intent=getIntent();
        latitude= Double.parseDouble(intent.getStringExtra("lat"));
        longitude= Double.parseDouble(intent.getStringExtra("lng"));
        init();
                AdRequest adRequest = new AdRequest.Builder().build();
                mAdView.loadAd(adRequest);*/
    }


    public  void init(){
        linearLayout=(LinearLayout)findViewById(R.id.linear);
        /*btn_cafe=(ImageView) findViewById(R.id.btn_cafe);
        btn_meal=(ImageView) findViewById(R.id.btn_meal);
        btn_liqued=(ImageView) findViewById(R.id.btn_liqued);
        btn_bar=(ImageView) findViewById(R.id.btn_bar);
        btn_restaurant=(ImageView) findViewById(R.id.btn_restaurant);
        btn_bakery=(ImageView) findViewById(R.id.btn_bakery);

        btn_cafe.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                String url = getUrl(latitude, longitude, "cafe", PROXIMITY_RADIUS);
                Intent intent=new Intent(HomeScreen.this,MapsActivity.class);
                intent.putExtra("url",url);
                intent.putExtra("lat",latitude);
                intent.putExtra("long",longitude);
                intent.putExtra("nb","cafe");
                startActivity(intent);

            }
        });

        btn_meal.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                String url = getUrl(latitude, longitude, "meal_delivery", PROXIMITY_RADIUS);
                Intent intent=new Intent(HomeScreen.this,MapsActivity.class);
                intent.putExtra("url",url);
                intent.putExtra("lat",latitude);
                intent.putExtra("long",longitude);
                intent.putExtra("nb","meal_delivery");
                startActivity(intent);

            }
        });

        btn_liqued.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                String url = getUrl(latitude, longitude, "liquor_store", PROXIMITY_RADIUS);
                Intent intent=new Intent(HomeScreen.this,MapsActivity.class);
                intent.putExtra("url",url);
                intent.putExtra("lat",latitude);
                intent.putExtra("long",longitude);
                intent.putExtra("nb","liquor_store");
                startActivity(intent);
            }
        });

        btn_bar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                String url = getUrl(latitude, longitude, "bar", PROXIMITY_RADIUS);
                Intent intent=new Intent(HomeScreen.this,MapsActivity.class);
                intent.putExtra("url",url);
                intent.putExtra("lat",latitude);
                intent.putExtra("long",longitude);
                intent.putExtra("nb","bar");
                startActivity(intent);

            }
        });

        btn_restaurant.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                String url = getUrl(latitude, longitude, "museum", PROXIMITY_RADIUS);
                Intent intent=new Intent(HomeScreen.this,MapsActivity.class);
                intent.putExtra("url",url);
                intent.putExtra("lat",latitude);
                intent.putExtra("long",longitude);
                intent.putExtra("nb","museum");
                startActivity(intent);

            }
        });*/

        linearLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                String url = getUrl(latitude, longitude, "museum", PROXIMITY_RADIUS);
                Intent intent=new Intent(HomeScreen.this,MapsActivity.class);
                intent.putExtra("url",url);
                intent.putExtra("lat",latitude);
                intent.putExtra("long",longitude);
                intent.putExtra("nb","museum");
                startActivity(intent);
            }
        });
    }

    private String getUrl(double latitude, double longitude, String nearbyPlace, int radius) {

        StringBuilder googlePlacesUrl = new StringBuilder("https://maps.googleapis.com/maps/api/place/nearbysearch/json?");
        googlePlacesUrl.append("location=" + latitude + "," + longitude);
        googlePlacesUrl.append("&radius=" + radius);
        googlePlacesUrl.append("&type=" + nearbyPlace);
        googlePlacesUrl.append("&sensor=true");
        googlePlacesUrl.append("&key=" + "AIzaSyDH8wdqaZhNIxZldg34Tl2c-35V0UQezAw");
        Log.d("getUrl", googlePlacesUrl.toString());
        return (googlePlacesUrl.toString());
    }
}